//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include "tccolor.h"
#include "Unit1.h"
#include <jpeg.hpp>


bool DrawFirStPos = true;
bool Masking = false;
bool gbMDown = false;
TRect grtLTRB;

//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
	ScrollBox1->DoubleBuffered = true;	// קKέC Image1 eخɪ{{{H
	ScrollBox2->DoubleBuffered = true;	// קKέC Image1 Bzɪ{{{H
	Image1->Visible = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if (OpenDialog1->Execute())
	{
		Image1->Picture->LoadFromFile(OpenDialog1->FileName);
		Image1->Picture->Bitmap->PixelFormat = pf24bit;
		Image1->Width  = Image1->Picture->Width;
		Image1->Height = Image1->Picture->Height;
        ScrollBox1->HorzScrollBar->Position = 0;
        ScrollBox1->VertScrollBar->Position = 0;
		Image1->Visible = true;
		Image2->Visible = false;

	}

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
	int x,y;
	TRGBTriple *ptr;	// ϥ TRGBTriple H{XŪ
	for (y=0; y<Image1->Height; y++)
	{
		ptr = (TRGBTriple *)Image1->Picture->Bitmap->ScanLine[y];  // ϥ ScanLine HBzt
		for (x=0; x<Image1->Width; x++)
		{
			if (ptr[x].rgbtGreen < 100)
			{
				ptr[x].rgbtRed   = 0;
				ptr[x].rgbtGreen = 0;
				ptr[x].rgbtBlue  = 0;
			}
			else
			{
				ptr[x].rgbtRed   = 255;
				ptr[x].rgbtGreen = 255;
				ptr[x].rgbtBlue  = 255;
			}
		}
	}

    Image1->Refresh();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
	int x, y;
	TRGBTriple *ptr;	// ϥ TRGBTriple H{XŪ
	for (y=0; y<Image1->Height; y++)
	{
		ptr = (TRGBTriple *)Image1->Picture->Bitmap->ScanLine[y];  // ϥ ScanLine HBzt
		for (x=0; x<Image1->Width; x++)
		{
			ptr[x].rgbtRed   = 255 - ptr[x].rgbtRed;
			ptr[x].rgbtGreen = 255 - ptr[x].rgbtGreen;
			ptr[x].rgbtBlue  = 255 - ptr[x].rgbtBlue;
		}
	}
    Image1->Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	gbMDown = true;
	grtLTRB.Left = X;
	grtLTRB.Top  = Y;
	grtLTRB.Right  = X;
	grtLTRB.Bottom = Y;

    Image1->Canvas->Brush->Style = bsClear;
    Image1->Canvas->Pen->Mode = pmXor;  // γ] pmNotXor
    Image1->Canvas->Pen->Style = psDot;
    Image1->Canvas->Pen->Color = clWhite;

    Image1->Canvas->Rectangle(grtLTRB);  // øsĤ@ (ɶȬ@I)
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1MouseMove(TObject *Sender, TShiftState Shift,
	int X, int Y)
{
	TCColor c = Image1->Canvas->Pixels[X][Y];

	Label1->Caption = (int)c.Red;
	Label2->Caption = (int)c.Green;
	Label3->Caption = (int)c.Blue;
	Label4->Caption = X;
	Label5->Caption = Y;

	if (gbMDown)
	{
		if (X<0) X = 0;
		if (X>Image1->Width) X = Image1->Width;
		if (Y<0) Y = 0;
		if (Y>Image1->Height) Y = Image1->Height;

		Image1->Canvas->Rectangle(grtLTRB);  // Me@øs¤

		grtLTRB.Right  = X;
		grtLTRB.Bottom = Y;

		Image1->Canvas->Rectangle(grtLTRB);  // øss
	}
//Label8->Caption = "left="+IntToStr(grtLTRB.Left)+", top="+IntToStr(grtLTRB.Top)+", right="+IntToStr(grtLTRB.Right)+", bottom="+IntToStr(grtLTRB.Bottom);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1MouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	gbMDown = false;

    Image1->Canvas->Rectangle(grtLTRB);

	// pGkyЭȤp󥪤AάOUyЭȤpWAh洫AHKBzʧ@Ϳ~
	int tmp;
	if (grtLTRB.Right < grtLTRB.Left)
    {
		tmp = grtLTRB.Right;
        grtLTRB.Right = grtLTRB.Left;
        grtLTRB.Left = tmp;
    }
	if (grtLTRB.Bottom < grtLTRB.Top)
    {
		tmp = grtLTRB.Bottom;
        grtLTRB.Bottom = grtLTRB.Top;
        grtLTRB.Top = tmp;
    }

	Image2->Width  = grtLTRB.Right  - grtLTRB.Left;
	Image2->Height = grtLTRB.Bottom - grtLTRB.Top;
	Image2->Picture->Bitmap->Width  = Image2->Width;
	Image2->Picture->Bitmap->Height = Image2->Height;
    Image2->Canvas->FillRect(Rect(0, 0, Image2->Width, Image2->Height));

    TRect DestRect = grtLTRB;
    OffsetRect(&DestRect, -grtLTRB.Left, -grtLTRB.Top);  // Nmq] Left=0, Top=0AOOӪe׻P

    Image2->Canvas->CopyRect(DestRect, Image1->Canvas, grtLTRB);

	if (Image2->Width < ScrollBox1->Width)	// pGIϼeפp ScrollBox e
    {
    	Image2->Left = (ScrollBox1->Width - Image2->Width) / 2;	// ~
    } else {
    	Image2->Left = 0;
    }
	if (Image2->Height < ScrollBox1->Height)	// pGIϰפp ScrollBox 
    {
    	Image2->Top = (ScrollBox1->Height - Image2->Height) / 2;	// ~
    } else {
    	Image2->Top = 0;
    }

	Image2->Visible = true;
}
//---------------------------------------------------------------------------


